require("stuff/preamble")

local prepro = lib.preprocessor

local vec, mat

vec = lib.stuff.LazyTable(function (N)
	local env = prepro.makeEnv()
	env.preRequire("templates/vec.lua")(N) --, M)
	return env.compile()()
end)

mat = lib.stuff.LazyTable(function (M)
	local env = prepro.makeEnv()
	env.preRequire("templates/vec.lua")(M*M, M)
	return env.compile()(vec[M])
end)

local matchPrefixInt = function (s, prefix)
	local p = s:sub(1,#prefix)
	if p == prefix then
		local i = tonumber(s:sub(#prefix+1))
		if i > 0 and i == math.floor(i) then
			return i
		end
	end
end

local la
la = lib.stuff.LazyTable(function(k)
	for _, pf in ipairs({"vec", "mat"}) do
		local num = matchPrefixInt(k, pf)
		if num then
			return la[pf][num]
		end
	end
end)

la.vec = vec
la.mat = mat

return la
