local Class = function(name, ...)
	local copyBlacklist = {_parents=0,_name=0,__index=0}
	local class = {}
	local classmeta = {}
	classmeta.__index = classmeta
	class.__index = class
	setmetatable(class, classmeta)
	local parents = {...}
	class._parents = {}
	class._name = name or "UnnamedClass"
	for parentIndex, parent in pairs(parents) do
		for k, v in pairs(parent) do
			if not copyBlacklist[k] then
				class[k] = v
			end
		end
		class._parents[parent] = 0
	end
	function classmeta:__call(...)
		local instance = {}
		setmetatable(instance, class)
		if instance.__init then
			instance:__init(...)
		end
		return instance
	end
	function class:ChildOf(parent)
		return self._parents[parent] ~= nil
	end
	function class:instanceOf(c)
		return c == class or self._parents[c] ~= nil
	end
	function class:__tostring()
		return self._name.."()"
	end
	return class
end

return Class
