
local function LazyTable(f)
	local mt = {}
	function mt:__index(key)
		local v = rawget(self, key) 
		if v == nil then
			self[key] = f(key)
			return self[key]
		else
			return v
		end
	end
	return setmetatable({}, mt)
end

return LazyTable
