local globalGuard = {}

function globalGuard.start(strict)
	local meta = {
		__newindex = function(self, key)
			assert(false, "Attempt to write global key: " .. tostring(key))
		end
	}
	if strict then
		meta.__index = function(self, key)
			assert(false, "Attempt to use undefined global: " .. tostring(key))
		end
	end
	
	setmetatable(
		_G,
		meta
	)
end

function globalGuard.stop()
	setmetatable(_G, {})
end

return globalGuard
