local LazyTable = require("stuff/LazyTable")

local function LazyLoader(path)
	path = path or ""
	return LazyTable(
		function(key)
			local name = path .. key
			if love then
				local info = love.filesystem.getInfo(name)
				if info and ({directory=1, symlink=1})[info.type] then
					return LazyLoader(name .. "/")
				end
			elseif path == "" and name == "stuff" then
				return LazyLoader("stuff/")
			end
			return require(name)
		end
	)
end

return LazyLoader


