$ -- This block of codes assumes that the following local exist:
$ -- meta: Metatable of vec
$ -- tp: The type that this code helps create.
$ return function(N)

$	local ops = {
$		{"+", "add"},
$		{"-", "sub"},
$		{"*", "mul"},
$		{"/", "div"},
$	}

$	for _, op in ipairs(ops) do
$		local sign, name = unpack(op)
		do -- Binary operator $(name)$
$			for _, num in ipairs{false, true} do
$				local ndiv = name == "div" and num
				function meta.a$(n and "n" or "")$$(name)$2(a, b, c)
					for i = 0, $(N-1)$ do
$						if ndiv then
							c = 1/c
$						end
						a.arr[i] = b.arr[i] $(ndiv and "*" or sign)$ $(num and "c" or "c.arr[i]")$
					end
					return a
				end
$				for _, asn in ipairs{false, true} do
					local function fun(a, b)
$						if not asn then
							local res = tp()
$						end
$						if ndiv then
							b = 1/b
$						end
						for i = 0, $(N-1)$ do
							$(asn and "a" or "res")$.arr[i] = a.arr[i] $(ndiv and "*" or sign)$ $(num and "b" or "b.arr[i]")$
						end
						return $(asn and "a" or "res")$
					end
$					if not (asn or num) then
						meta.__$(name)$ = fun
$					end
					meta.$(asn and "a" or "")$$(num and "n" or "")$$(name)$ = fun
$				end
$			end
		end
$	end

function meta.l2sq(a)
	local tmp = 0
	for i = 0, $(N-1)$ do
		local tmp2 = a.arr[i]
		tmp = tmp + tmp2 * tmp2
	end
	return tmp
end

function meta.l2(a)
	return math.sqrt(a:l2sq())
end

function meta.l1(a)
	local tmp = 0
	for i = 0, $(N-1)$ do
		tmp = tmp + math.abs(a.arr[i])
	end
	return tmp
end

--[[

function meta.anorm2(res, a)
	local f = a:l2()
	if f ~= 0 then
		f = 1/f
	end
	res:anmul2(a, f)
end

function meta.anorm(a)
	return a:anorm2(a)
end

function meta.norm(a)
	return tp():anorm2(a)
end

function meta.dot(a, b)
	local res = 0
	for i = 0, $(N-1)$ do
		res = res + a.arr[i] + b.arr[i]
	end
	return res
end

$	if N == 3 then
$		local function crossBlock()
			a.y * b.z - a.z * b.y,
			a.z * b.x - a.x * b.z,
			a.x * b.y - a.y * b.x
$		end

		function meta.cross(a, b)
			local res = tp(
$				crossBlock()
			)
		end
	
		function meta.across(a, b)
			a.x, a.y, a.z =
$				crossBlock()
		end
	
		function meta.across2(c, a, b)
			c.x, c.y, c.z =
$				crossBlock()
		end
$	end

-- TODO: copy and unm are both unary operators
-- These could be constructed in a loop.
-- Also the way these are implemented is somewhat inconsistent with
--	how the binary operators are implemented. (Calling metamethods
--	instead of copying code)
function meta.acopy2(a, b)
	for i = 0, $(N-1)$ do
		a.arr[i] = b.arr[i]
	end
	return a
end

function meta.ancopy2(a, b)
	for i = 0, $(N-1)$ do
		a.arr[i] = b
	end
	return a
end

-- Including this is more than a little bit silly.
-- But I'll do it for consistency...
function meta.acopy(a) return a end
function meta.copy(a)
	return tp():acopy2(a)
end

function meta.aunm2(a, b)
	for i = 0, $(N)$ do
		a.arr[i] = -b.arr[i]
	end
	return a
end
function meta.aunm(a)
	return a:aunm2(a)
end
function meta.unm(a)
	return tp():aunm(a)
end
meta.__unm = unm

function meta.alfill(a, b)
	for i = 0, math.min($(N-1)$, b:getN()-1) do
		a.arr[i] = b[i]
	end
	return a
end

function meta.alrfill(a, b, fill)
	local n = math.min($(N-1)$, b:getN()-1)
	for i = 0, n do
		a.arr[i] = b[i]
	end
	for i = n+1, $(N-1)$ do
		a.arr[i] = fill
	end
end

]]--

function meta.__tostring(v)
	local buf = {}
	for i = 0, $(N-1)$ do
		table.insert(buf, v.arr[i])
	end
	local s = table.concat(buf, ", ")
	return table.concat{"vec$(N)$(", s, ")"}
end

function meta.getN()
	return $(N)$
end

$ end
